<!DOCTYPE html>
<html lang="de-de">

<head>
<title>Update PV Database</title>
</head>
<body>
 <div style="margin: 30px;min-height:500px;">
  <h3>Update PV Database</h3>
  

  <form method="post" enctype="multipart/form-data"
   action="<?php echo $_SERVER['PHP_SELF']; ?>">
   <br> <label>W&auml;hle eine CSV Datei (*.csv) von deinem Rechner aus.<br>
    <br> <input name="datei" type="file" size="50" accept="*">
   </label> <b><i><br>&nbsp;&nbsp; </b></i> <br>
   <button>run update</button>
   &nbsp;
  </form>

<?php

require_once 'pv_system_settings.php';
$key = $parms['key'];
$id_token = $parms['id_token'];

if (array_key_exists('datei', $_FILES))
    if ($_FILES['datei']['name'] != "")
        sql_update();
    else
        echo "<br><b>... bitte zuerst Datei ausw&auml;hlen ...</b>";

function sql_update ()
{
    require_once 'httpClient.class.php';
    include 'pv_system_settings.php';

    $key = $parms['key'];
    $id = $parms['id_token'];
    $host = $parms['host'];
    $host2 = $parms['host2'];
    $updateUrl = $parms['update_url'];

    $name = $_FILES['datei']['name'];
    $file = $_FILES['datei']['tmp_name'];

    echo "\n<br> using file &quot;$name&quot; <br>";

    if (file_exists($file))
        $fp = fopen($file, "r");
    else
    {
        echo "\n<br>*** file not found: $file ***";
        exit(- 1);
    }

    $line = fgets($fp);
    $count = 0;
    $k = 0;
    $z = 0;
    $sql_data = array();
    $datum = "first";
    $today = date("Y-m-d");
    $line_count = count(file($file)) - 2;
    if ($line_count < 3)
    {
      echo "Invalid file - no valid data found";
      exit;
    }
    $corr_value = $parms['corr_value'];

    while (! feof($fp))
    {
        $line = fgets($fp);
        $line = str_replace(",", ".", $line);
        $temp = explode(";", $line);

        if (count($temp) > 7)
        {
            $date_time = explode(" ", $temp[0]);
            $date_temp = explode(".", $date_time[0]);
            $time[$count] = $date_time[1];
            $date[$count] = $date_temp[2] . "-" . $date_temp[1] . "-" . $date_temp[0];
            // $time[$count] = $date_time[1];
            // $datetime[$count] = $date . " " . $time[$count];

            //if ($temp[6] < 0.01)
            //    $temp[6] = 0;

            if ($date[$count] != $today && $count < $line_count )
            {
                if ($date[$count] == $datum)
                {
                    $netzbezug = $netzbezug + ($temp[1] * $corr_value[1]);
                    $netzeinspeisung = $netzeinspeisung + ($temp[2] * $corr_value[2]);
                    $stromverbrauch = $stromverbrauch + ($temp[3] * $corr_value[3]);
                    $akku_beladung = $akku_beladung + ($temp[4] * $corr_value[4]);
                    $akku_entnahme = $akku_entnahme + ($temp[5] * $corr_value[5]);
                    $stromerzeugung = $stromerzeugung + ($temp[6] * $corr_value[6]);

                    $sql_data[$k] = array(
                            $datum,
                            $netzbezug,
                            $netzeinspeisung,
                            $stromverbrauch,
                            $akku_beladung,
                            $akku_entnahme,
                            $stromerzeugung
                    );
                }
                else
                {
                    $datum = $date[$count];
                    $netzbezug = $temp[1] * $corr_value[1];
                    $netzeinspeisung = $temp[2] * $corr_value[2];
                    $stromverbrauch = $temp[3] * $corr_value[3];
                    $akku_beladung = $temp[4] * $corr_value[4];
                    $akku_entnahme = $temp[5] * $corr_value[5];
                    $stromerzeugung = $temp[6] * $corr_value[6];
                    if ($count > 0)
                        $k ++;
                }
            }
            $count ++;
        }
    }

    fclose($fp);
   
    $val = $parms['vals_per_hour'];
    //echo "<br> measurements per hour: $val <br>";
    
    for ($i = 0; $i <= $k; $i ++)
    {
        $sql_data[$i][1] = round($sql_data[$i][1] / $val, 3);
        if ($sql_data[$i][1] < 0.15)
            $sql_data[$i][1] = 0;
        $sql_data[$i][2] = round($sql_data[$i][2] / $val, 3);
        $sql_data[$i][3] = round($sql_data[$i][3] / $val, 3);
        $sql_data[$i][4] = round($sql_data[$i][4] / $val, 3);
        $sql_data[$i][5] = round($sql_data[$i][5] / $val, 3);
        $sql_data[$i][6] = round($sql_data[$i][6] / $val, 3);
    }

    processHTTPRequest($host, $updateUrl, 'daily', $sql_data);
    if ($host2 != "")
        processHTTPRequest($host2, $updateUrl, 'daily', $sql_data);
}

function encrypt ($message, $key, $encode = false)
{
    $method = 'aes-256-ctr';

    $nonceSize = openssl_cipher_iv_length($method);
    $nonce = openssl_random_pseudo_bytes($nonceSize);

    $ciphertext = openssl_encrypt($message, $method, $key, OPENSSL_RAW_DATA, $nonce);

    // Now let's pack the IV and the ciphertext together
    // Naively, we can just concatenate
    if ($encode)
    {
        return base64_encode($nonce . $ciphertext);
    }
    return $nonce . $ciphertext;
}

function processHTTPRequest ($host, $updateUrl, $type, $sql_data)
{
    global $key, $id_token;

    // build security token:
    $id = encrypt($id_token, $key);

    $data_string = json_encode($sql_data);
    $data_string = encrypt($data_string, $key);

    $data = array(
            'id' => $id,
            'type' => $type,
            'verbose' => false,
            'data' => $data_string
    );
    $path = $updateUrl;

    // post request:
    $client = new HttpClient($host);
    if ($client->post($path, $data) == false)
    {
        $date = date("m.d.Y - G:i");
        echo "\n<br>" . $date . ": An error occurred: " . $client->getError();
        echo "\n<br>Http error status: " . $client->getStatus();
    }
    else
        echo "\n<br />$host reports: " . $client->getContent() . "\n";

    return;
}

?>
 
 </div>
</body>
</html>