SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

-- --------------------------------------------------------

--
-- Tabellenstruktur fÃ¼r Tabelle 'jos_pv_senec_day'
--

CREATE TABLE `jos_pv_senec_day` (
  `id` datetime NOT NULL,
  `date` date NOT NULL,
  `time` time NOT NULL,
  `Netzbezug` float DEFAULT NULL,
  `Netzeinspeisung` float DEFAULT NULL,
  `Stromverbrauch` float DEFAULT NULL,
  `Akku_Beladung` float DEFAULT NULL,
  `Akku_Entnahme` float DEFAULT NULL,
  `Stromerzeugung` float DEFAULT NULL,
   UNIQUE KEY id (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Tabellenstruktur fÃ¼r Tabelle 'jos_pv_senec_days'
--
CREATE TABLE `jos_pv_senec_days` (
  `date` date NOT NULL,
  `Netzbezug` float DEFAULT NULL,
  `Netzeinspeisung` float DEFAULT NULL,
  `Stromverbrauch` float DEFAULT NULL,
  `Akku_Beladung` float DEFAULT NULL,
  `Akku_Entnahme` float DEFAULT NULL,
  `Stromerzeugung` float DEFAULT NULL,
   UNIQUE KEY id (date)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Tabellenstruktur für Tabelle 'jos_pv_senec_year'
--
CREATE TABLE IF NOT EXISTS jos_pv_senec_year (
  `date` date NOT NULL,
  `month` varchar(10) NOT NULL,
  `Netzbezug` float DEFAULT NULL,
  `Netzeinspeisung` float DEFAULT NULL,
  `Stromverbrauch` float DEFAULT NULL,
  `Stromerzeugung` float DEFAULT NULL,   UNIQUE KEY id (date)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Daten für Tabelle 'jos_pv_daten_jahr'
--

INSERT INTO jos_pv_senec_year (date, month) VALUES
('2021-01-31', 'Januar'),
('2021-02-28', 'Februar'),
('2021-03-31', 'März'),
('2021-04-30', 'April'),
('2021-05-31', 'Mai'),
('2021-06-30', 'Juni'),
('2021-07-31', 'Juli'),
('2021-08-31', 'August'),
('2021-09-30', 'September'),
('2021-10-31', 'Oktober'),
('2021-11-30', 'November'),
('2021-12-31', 'Dezember'),
('2022-01-31', 'Januar'),
('2022-02-29', 'Februar'),
('2022-03-31', 'März'),
('2022-04-30', 'April'),
('2022-05-31', 'Mai'),
('2022-06-30', 'Juni'),
('2022-07-31', 'Juli'),
('2022-08-31', 'August'),
('2022-09-30', 'September'),
('2022-10-31', 'Oktober'),
('2022-11-30', 'November'),
('2022-12-31', 'Dezember'),
('2023-01-31', 'Januar'),
('2023-02-28', 'Februar'),
('2023-03-31', 'März'),
('2023-04-30', 'April'),
('2023-05-31', 'Mai'),
('2023-06-30', 'Juni'),
('2023-07-31', 'Juli'),
('2023-08-31', 'August'),
('2023-09-30', 'September'),
('2023-10-31', 'Oktober'),
('2023-11-30', 'November'),
('2023-12-31', 'Dezember'),
('2024-01-31', 'Januar'),
('2024-02-28', 'Februar'),
('2024-03-31', 'März'),
('2024-04-30', 'April'),
('2024-05-31', 'Mai'),
('2024-06-30', 'Juni'),
('2024-07-31', 'Juli'),
('2024-08-31', 'August'),
('2024-09-30', 'September'),
('2024-10-31', 'Oktober'),
('2024-11-30', 'November'),
('2024-12-31', 'Dezember');
