<?php
$parms = array();
require_once 'pv_system_settings.php';
$key = $parms['key'];

if (array_key_exists('id', $_POST))
    $id = $_POST['id'];
else
{
    echo "<br>Missing id-token - process aborted";
    exit();
}

$id = decrypt($id, $key);
if ($id != $parms['id_token'])
{
    echo "<br>invalid id-token - process aborted";
    exit();
}

$data = decrypt($_POST['data'], $key);
$data = json_decode($data);
if ($data == null)
{
    echo "<br>invalid data - process aborted";
    exit();
}

$verbose = $_POST['verbose'];
$type = $_POST['type'];

$jos = $parms['table_prefix'];
$db_config = $_SERVER['DOCUMENT_ROOT'] . $parms['dbconfig'];

// create sql-statements from $data
$sql = array();
for ($i = 0; $i < count($data); $i ++)
{

    $sql[$i] = "insert into " . $jos . "pv_senec_days (date,Netzbezug,Netzeinspeisung,Stromverbrauch,Akku_Beladung,Akku_Entnahme,Stromerzeugung) values('" . $data[$i][0] . "','" . $data[$i][1] . "','" . $data[$i][2] . "','" . $data[$i][3] . "','" . $data[$i][4] . "','" . $data[$i][5] . "','" .
            $data[$i][6] . "');";
}

$temp = explode("-", $data[0][0]);
$month1 = $temp[1];
$year1 = $temp[0];
$temp = explode("-", $data[$i - 1][0]);
$month2 = $temp[1];
$year2 = $temp[0];

$month_names = array(
        "null",
        "January",
        "February",
        "March",
        "April",
        "May",
        "June",
        "July",
        "August",
        "September",
        "October",
        "November",
        "December"
);

// if ($verbose)
$mon1 = intval($month1);
$mon2 = intval($month2);
if ($month1 == $month2)
    echo "\n<br />...updating $type statistics for $month_names[$mon1] $year1";
else
    echo "\n<br />...updating $type statistics for $month_names[$mon1] $year1 and $month_names[$mon2] $year2";

processSQLRequest($db_config, $sql, $verbose);

// if ($verbose)
echo "\n<br />...updating yearly statistics for $month_names[$mon1] $year1 ...";
// update year's data
$sql = array();
$sql[0] = "select sum(Netzbezug), sum(Netzeinspeisung),
              sum(Stromverbrauch), sum(Stromerzeugung)
              from " . $jos . "pv_senec_days where (date>='$year1-$month1-01' and date<='$year1-$month1-31')";
// echo "<br>" . $sql[0];
$sum = processSQLRequest($db_config, $sql, $verbose);
for ($i = 0; $i < count($sum); $i ++)
    $sum[$i] = round($sum[$i], 3);
$sql[0] = "UPDATE " . $jos . "pv_senec_year SET
              Netzbezug = '$sum[0]',
              Netzeinspeisung = '$sum[1]',
              Stromverbrauch = '$sum[2]',
              Stromerzeugung = '$sum[3]'
              WHERE date like '$year1-$month1-%'";
$sum = processSQLRequest($db_config, $sql, $verbose);

if ($month1 != $month2)
{
    $mon = ltrim($month2, 0);
    echo "\n<br />...updating yearly statistics for $month_names[$mon] $year2 ...";
    // update year's data
    $sql = array();
    $sql[0] = "select sum(Netzbezug), sum(Netzeinspeisung),
              sum(Stromverbrauch), sum(Stromerzeugung)
              from " . $jos . "pv_senec_days where (date>='$year2-$month2-01' and date<='$year2-$month2-31')";
    // echo "<br>" . $sql[0];
    $sum = processSQLRequest($db_config, $sql, $verbose);
    for ($i = 0; $i < count($sum); $i ++)
        $sum[$i] = round($sum[$i], 3);
    $sql[0] = "UPDATE " . $jos . "pv_senec_year SET
              Netzbezug = '$sum[0]',
              Netzeinspeisung = '$sum[1]',
              Stromverbrauch = '$sum[2]',
              Stromerzeugung = '$sum[3]'
              WHERE date like '$year2-$month2-%'";
    $sum = processSQLRequest($db_config, $sql, $verbose);
}

exit();

function decrypt ($message, $key, $encoded = false)
{
    $method = 'aes-256-ctr';

    if ($encoded)
    {
        $message = base64_decode($message, true);
        if ($message === false)
        {
            throw new Exception('Encryption failure');
        }
    }

    $nonceSize = openssl_cipher_iv_length($method);
    $nonce = mb_substr($message, 0, $nonceSize, '8bit');
    $ciphertext = mb_substr($message, $nonceSize, null, '8bit');

    $plaintext = openssl_decrypt($ciphertext, $method, $key, OPENSSL_RAW_DATA, $nonce);

    return $plaintext;
}

function processSQLRequest ($db_config, $sql, $verbose, $debug = false)
{
    require_once ($db_config);

    $jconfig = new JConfig();
    $db = $jconfig->db;
    $dbuser = $jconfig->user;
    $dbpw = $jconfig->password;
    $error = false;
    $sum = null;

    $connection = mysqli_connect("localhost", $dbuser, $dbpw, $db);
    if ($connection == null)
    {
        echo "could not connect to database $db";
        return "-1";
    }

    mysqli_query($connection, "set character set utf8;");

    $error_count = 0;
    $success = 0;
    $duplicate = 0;

    for ($i = 0; $i < count($sql); $i ++)
    {
        // echo "\n<br /> $sql[$i]";
        $result = mysqli_query($connection, $sql[$i]);

        if (stristr($sql[0], "select"))
        {
            if ($result)
            {
                while ($row = $result->fetch_row())
                {
                    $sum = $row;
                }
            }
        }

        if ($result == false)
        {
            $error = mysqli_error($connection);
            if (stristr($error, "Duplicate"))
                $duplicate ++;

            if ($debug)
            {
                echo "\n<br />SQL failed:  $sql[$i]";
                echo "\n<br />Error msg: $error";
                $error_count ++;
            }
            else
                $error_count ++;
        }
        elseif ($debug)
        {
            echo "\n<br />SQL processed: $sql[$i]";
            $success ++;
        }
        else
            $success ++;
    }

    if (stristr($sql[0], "select") === false)
    {
        if (count($sql) > 1)
            $requests = " DB-Update requests, ";
        else
            $requests = " DB-Update request, ";

        $msg = "\n<br />Result: ";
        $msg .= count($sql) . "$requests successful:  $success";
        if ($error)
            $msg .= ", errors: $error_count,  caused by duplicate keys: $duplicate";
        else
            $msg .= " (no errors)";
        echo $msg;
    }

    return $sum;
}

?>